#pragma once
#include <Result.h>
#include <Types.h>

namespace MemoryManager
{
    void init();

    Result<u64> alloc_physical_page();
    Result<void> free_physical_page(u64 page);

    void lock_page(u64 page);
    void lock_pages(u64 pages, u64 count);

    u64 free();
    u64 used();
    u64 reserved();
}